﻿Imports System.ComponentModel

Public Class frmMultiInk

	Dim inhTyp As String = ""
	Dim lastTyp As String = ""
	Dim lastInh As Object = Nothing
	Dim inhObj As Object = Nothing
	Dim fileList As Specialized.StringCollection
	Dim clip As String = ""
	Dim fi(), ex() As String
	Dim scIcon As String =
		"\Iconica-Pastel-Program-group.ico"  ' das Icon für die Gruppen-Verknüpfung

	Public Sub New()
		MyBase.New()
		InitializeComponent()
		Visible = False
	End Sub

	Private Sub frmMultiInk_Load(sender As Object, e As EventArgs) Handles MyBase.Load
		Dim args = My.Application.CommandLineArgs 'lesen Befehlszeile
		' Wenn Befehlszeile nicht leer, dann anderes Startverhalten des Programms:
		If My.Application.CommandLineArgs.Count > 0 Then
			' Das Programm arbeitet als Startprogramm für die
			' in der Befehlszeile angegebenen Programme der Gruppe
			Try
				ReDim ex(args.Count - 1)
				For i As Short = 0 To args.Count - 1
					ex(i) = Replace(args.Item(i), "~", " ")
				Next
				For i As Short = 0 To ex.Length - 1
					Dim p As New Process
					With p
						.StartInfo.FileName = ex(i)
						.StartInfo.WorkingDirectory = IO.Path.GetDirectoryName(ex(i))
						MessageBox.Show(ex(i))
						.Start()
					End With
				Next
				Application.Exit()
			Catch ex As Exception
				Application.Exit()
			End Try
		Else
			' Andererseits (ohne Kommandozeile) arbeitet das Programm
			' als Generierung für Verknüpfungsgruppen
			Visible = True
			dhhelpShortCut.rtfFileName = Application.StartupPath + "\Hilfe.rtf"
		End If
		Timer1.Enabled = True   ' Timer starten
	End Sub

	Private Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
		' Prüfen, ob eine Verknüpfung im Clipboard ist
		inhTyp = testClipboard()
		inhObj = readClipboard(inhTyp)
		If inhTyp = "fdl" Then
			' Es ist eine Verknüpfung im Clipboard
			fileList = My.Computer.Clipboard.GetFileDropList()
			' Prüfen, ob sich Clipboard-Inhalt geändert hat
			If IsNothing(lastInh) OrElse Not (lastInh.Equals(fileList(0))) Then
				' Vergleichswert hat sich geändert (Clipboard-Inhalt)
				lastInh = fileList(0)
				clip = If(fileList(0).ToString.EndsWith(".lnk"), fileList(0), "")
				If clip <> "" Then
					' Verknüpfungsdaten ins DatagridView einfügen
					dgInkGroup.Rows.Add(New String() {clip})
				End If
			End If
		End If
	End Sub

	Private Sub btnCreate_Click(sender As Object, e As EventArgs) Handles btnCreate.Click
		' Verknüpfung erstellen
		dgInkGroup.ClearSelection()
		setArrays() ' bestimmte Felder erzeugen
		' Aufruf der Funktion zum Erstellen der neuen Gruppen-Verknüpfung
		CreateShortcut2(Environment.GetFolderPath(Environment.SpecialFolder.Desktop),
							 txtGroupname.Text,
							 Application.ExecutablePath,
							 txtGroupDescription.Text,
							 Join(ex, " "),
							 Application.StartupPath + scIcon,
							 Application.StartupPath)
	End Sub

	Private Sub btnTimer_Click(sender As Object, e As EventArgs) Handles btnTimer.Click
		' Timer Start/Stop
		dgInkGroup.ClearSelection()
		Timer1.Enabled = Not Timer1.Enabled
		btnCreate.Enabled = Not Timer1.Enabled
		ProgressBar1.Visible = Timer1.Enabled
		If Timer1.Enabled Then
			btnTimer.Text = "Timer Stop"
		Else
			btnTimer.Text = "Timer Start"
		End If
	End Sub

	Private Sub setArrays()
		' Felder mit Verknüpfungsdaten erstellen
		Dim chb As Short = dgInkGroup.Rows.Count - 1
		ReDim Preserve fi(chb)
		ReDim Preserve ex(chb)
		For i As Short = 0 To chb
			fi(i) = dgInkGroup.Rows(i).Cells(0).Value ' Verknüpfung
			ex(i) = Replace(ReadLnk(fi(i), True), " ", "~")
		Next
	End Sub

	Private Sub frmMultiInk_HelpButtonClicked(sender As Object, e As CancelEventArgs) _
		Handles Me.HelpButtonClicked
		' Hilfe aufrufen
		dhhelpShortCut.Show()
	End Sub
End Class
